# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from dataclasses import dataclass

from typing import TYPE_CHECKING, Callable

import time
from influxdb_client import InfluxDBClient
from influxdb_client.client.write_api import SYNCHRONOUS

from labdata_aggregator.db_writer import DataBaseWriter

from sila2.server import MetadataDict

from ..generated.influxdbcontroller import (
    CreateToken_Responses,
    InfluxDBControllerBase,
    QueryInfluxDB_Responses,
    SetBucket_Responses,
    SetOrganisation_Responses,
    SetToken_Responses,
)

if TYPE_CHECKING:
    from ..server import Server


@dataclass
class InfluxDB_config:
    token: str
    host: str
    org: str
    bucket: str
    client: Callable
    api: Callable


class InfluxDBControllerImpl(InfluxDBControllerBase):
    def __init__(self, parent_server: Server) -> None:
        super().__init__(parent_server=parent_server)

        self.token = "token_not_set"
        self.influxDB_port = '8086'
        self.influxDB_host = "http://localhost:"  # '127.0.0.1:'

        self.org = "org.lara"
        self.bucket = "LARAbucket"

        self.database_writer = DataBaseWriter()

    def get_config(self):
        self.influxDB_client = InfluxDBClient(
            url=self.influxDB_host + self.influxDB_port, token=self.token, org=self.org)  # debug=False

        self.influxDB_write_api = self.influxDB_client.write_api(
            write_options=SYNCHRONOUS)

        return InfluxDB_config(token=self.token, host=self.influxDB_host, org=self.org, bucket=self.bucket, client=self.influxDB_client, api=self.influxDB_write_api)

    def start_measurement(self, name):
        self.database_writer.start_measurement(
            influxDB_config=self.get_config(), measurement=name)
        # self.database_writer.start_measurement(
        #     influxDB_config="", measurement=name)

    def stop_measurement(self):
        self.database_writer.stop_measurement()

    def set_feature_calls(self, feature_calls):
        self.database_writer.feature_calls = feature_calls

    def get_Token(self, *, metadata: MetadataDict) -> str:
        return self.token

    def get_Organisation(self, *, metadata: MetadataDict) -> str:
        return self.org

    def get_Bucket(self, *, metadata: MetadataDict) -> str:
        return self.bucket

    def CreateToken(self, Token: str, *, metadata: MetadataDict) -> CreateToken_Responses:
        raise NotImplementedError  # TODO

    def SetToken(self, Token: str, *, metadata: MetadataDict) -> SetToken_Responses:
        self.token = Token
        return SetToken_Responses()

    def SetOrganisation(self, Organisation: str, *, metadata: MetadataDict) -> SetOrganisation_Responses:
        self.org = Organisation
        return SetOrganisation_Responses()

    def SetBucket(self, Bucket: str, *, metadata: MetadataDict) -> SetBucket_Responses:
        self.bucket = Bucket
        return SetBucket_Responses()

    def QueryInfluxDB(self, Query: str, QueryResultType: str, *, metadata: MetadataDict) -> QueryInfluxDB_Responses:
        raise NotImplementedError  # TODO
